#include <ddk/ntddk.h>

#define DEVICE_NAME  L"\\Device\\Ahonto"

NTSTATUS 
AhontoOpen( 
	IN PDEVICE_OBJECT DeviceObject, 
	IN PIRP Irp);

NTSTATUS 
AhontoClose(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp);

VOID
AhontoUnload(
	IN PDRIVER_OBJECT DriverObject);

NTSTATUS DriverEntry(
	IN PDRIVER_OBJECT DriverObject,
	IN PUNICODE_STRING RegistryPath)
{
	PDEVICE_OBJECT DeviceObject = NULL;
	NTSTATUS Status;
	UNICODE_STRING DeviceName;

	RtlInitUnicodeString( &DeviceName, DEVICE_NAME );

	Status = IoCreateDevice(
					DriverObject,
					0, 
					&DeviceName, 
					FILE_DEVICE_UNKNOWN,
					0,
					FALSE,
					&DeviceObject);

	if ( NT_SUCCESS(Status) ){
		DriverObject->MajorFunction[IRP_MJ_CREATE] = AhontoOpen;
		DriverObject->MajorFunction[IRP_MJ_CLOSE]  = AhontoClose;
		DriverObject->DriverUnload                 = AhontoUnload;
		
		KdPrint( (DEVICE_NAME " Initialized Device \n") );
	}
	else {
		KdPrint( (DEVICE_NAME " Fatal CreateDevice \n") );
	}
	return Status;
}

NTSTATUS
AhontoOpen(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp)
{
	KdPrint( (DEVICE_NAME " Opened\n") ); 
	
	Irp->IoStatus.Status = STATUS_SUCCESS;
	Irp->IoStatus.Information = 0; 
	
	IoCompleteRequest( Irp, IO_NO_INCREMENT ); 
	
	return STATUS_SUCCESS;
}

NTSTATUS
AhontoClose(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp)
{
	KdPrint( (DEVICE_NAME " Closed\n") );
	
	Irp->IoStatus.Status = STATUS_SUCCESS; 
	Irp->IoStatus.Information = 0;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	
	return STATUS_SUCCESS;
}

VOID 
AhontoUnload(
	IN PDRIVER_OBJECT DriverObject)
{
	KdPrint( (DEVICE_NAME " Unload\n") ); 
	
	IoDeleteDevice( DriverObject->DeviceObject );
}
